#include "Dot.h"

// VO-like class. No logic much.

dot::dot(void)
{
	_x = 0;
	_y = 0;
	speed = 0;
	direction = dot::DIR_NONE;
}

dot::dot(float $x, float $y)
{
	_x = $x;
	_y = $y;
	direction = dot::DIR_NONE;
	speed = 0;
}

dot::dot(float $x, float $y, int $direction)
{
	_x = $x;
	_y = $y;
	direction = $direction;
	speed = 0;
}

dot::~dot(void)
{
}

void dot::set(float $x, float $y)
{
	_x = $x;
	_y = $y;
}

float dot::getX()
{
	return _x;
}

float dot::getY()
{
	return _y;
}

void dot::update()
{
	switch (direction)
	{
		case dot::DIR_LEFT:
			set( getX() - speed, getY() );
			break;
		case dot::DIR_RIGHT:
			set( getX() + speed, getY() );
			break;
		case dot::DIR_UP:
			set( getX(), getY() - speed );
			break;
		case dot::DIR_DOWN:
			set( getX(), getY() + speed );
			break;
	}
}

int dot::oppositeDirectionOf(int i)
{
	switch (i)
	{
		case dot::DIR_LEFT:
			return dot::DIR_RIGHT;
			break;
		case dot::DIR_RIGHT:
			return dot::DIR_LEFT;
			break;
		case dot::DIR_UP:
			return dot::DIR_DOWN;
			break;
		case dot::DIR_DOWN:
			return dot::DIR_UP;
			break;
	}
	return dot::DIR_NONE;
}
