#include "dots.h"

dots::dots(void)
{
	_counter = -1;
	_defaultSpeed = 0.0625;

	// * speeds of	(0,0.5] work
	//				(5, 1.0) don't
	//				and 1 works
}

dots::~dots(void)
{
}

void dots::setMaze(maze* $m)
{
	_m = $m;
}

void dots::setDefaultSpeed(float f)
{
	_defaultSpeed = f;
}

void dots::addDotAtOrigin()
{
	float x = _m->getStartPos()->x;
	float y = _m->getStartPos()->y;
	int dir = _m->getStartDirection();

	// actually place it 1 off of maze
	switch(dir)
	{
		case dot::DIR_RIGHT:
			x--;
			break;
		case dot::DIR_LEFT:
			x++;
			break;
		case dot::DIR_DOWN:
			y--;
			break;
		case dot::DIR_UP:
			y++;
			break;
	}

	dot d = dot(x,y, dir);
	d.speed = _defaultSpeed;

	_dots.push_back(d);
}

void dots::addDotAt(int x, int y)
{
}

void dots::update()
{
	_dieList.clear();

	for (int i = 0; i != _dots.size(); i++) 
	{
		float wasx = _dots[i].getX();
		float wasy = _dots[i].getY();

		_dots[i].update();

		if (_m->isInBounds(_dots[i], true))
		{
			testDot(i, wasx, wasy);
		} 
		else 
		{
			printf("die.");
			_dieList.push_back(i);
		}
	}

	for (int i = _dieList.size()-1; i >= 0; i--)
	{
		int idx = _dieList[i];
		_dots.erase(_dots.begin()+idx);
	}

	//

	_counter++;

	// add condition
	if (_counter % 100 == 0 && _dots.size() < _m->getRecommendedMaxDots())
	{
		addDotAtOrigin();
	}
}

void dots::testDot(int i, float wasx, float wasy)
{
	// this logic sucks.

	int x = leeUtil::round(_dots[i].getX());
	int y = leeUtil::round(_dots[i].getY());

	if (_dots[i].direction == dot::DIR_LEFT || _dots[i].direction == dot::DIR_RIGHT)
	{
		if ( (wasx < (float)x && _dots[i].getX() >= (float)x) ||  (wasx > (float)x && _dots[i].getX() <= (float)x) )
		{
			// [1] does dot hit wall?

			if (_dots[i].direction == dot::DIR_LEFT && _m->isBlockedLeft(x,y)) {
				_dots[i].set(x,_dots[i].getY());
				pickDirection(&_dots[i], false);
				return;
			}
			if (_dots[i].direction == dot::DIR_RIGHT && _m->isBlockedRight(x,y)) {
				_dots[i].set(x,_dots[i].getY());
				pickDirection(&_dots[i], false);
				return;
			}

			// [2] is there an opening in an orthogonal direction?

			if (_m->isBlockedUp(x,y) == false || _m->isBlockedDown(x,y) == false)
			{
				_dots[i].set(x,y); // xxx
				pickDirection(&_dots[i], false);
				return;
			}
		}
	}

	if (_dots[i].direction == dot::DIR_UP || _dots[i].direction == dot::DIR_DOWN)
	{
		if ( (wasy < y && _dots[i].getY() >= y) ||  (wasy > y && _dots[i].getY() <= y) )
		{
			// [1] does dot hit wall?

			if (_dots[i].direction == dot::DIR_UP && _m->isBlockedUp(x,y)) {
				_dots[i].set(_dots[i].getX(),y);
				pickDirection(&_dots[i], false);
				return;
			}
			if (_dots[i].direction == dot::DIR_DOWN && _m->isBlockedDown(x,y)) {
				_dots[i].set(_dots[i].getX(),y);
				pickDirection(&_dots[i], false);
				return;
			}

			// [2] is there an opening in an orthogonal direction?

			if (_m->isBlockedLeft(x,y) == false || _m->isBlockedRight(x,y) == false)
			{
				_dots[i].set(x,y); // xxx
				pickDirection(&_dots[i], false);
				return;
			}
		}
	}
}

dot* dots::getDotAt(int i)
{
	return &_dots.at(i);
}

int dots::getSize()
{
	return _dots.size();
}

//

void dots::pickDirection(dot* d, bool $respectBounds)
{
	// assumes dot.x/y are ints!

	int x = (int)d->getX();
	int y = (int)d->getY();

	_scratch.clear();

	// add legal directions to vector

	if (! $respectBounds)
	{
		if (!_m->isBlockedLeft(*d)) 
			_scratch.push_back(dot::DIR_LEFT);
		if (!_m->isBlockedRight(*d))
			_scratch.push_back(dot::DIR_RIGHT);
		if (!_m->isBlockedUp(*d)) 
			_scratch.push_back(dot::DIR_UP);
		if (!_m->isBlockedDown(*d)) 
			_scratch.push_back(dot::DIR_DOWN);
	}
	else
	{
		if (x > 0 && !_m->isBlockedLeft(*d)) 
			_scratch.push_back(dot::DIR_LEFT);
		if (x < _m->getWidth()-2 && !_m->isBlockedRight(*d))
			_scratch.push_back(dot::DIR_RIGHT);
		if (y > 0 && !_m->isBlockedUp(*d)) 
			_scratch.push_back(dot::DIR_UP);
		if (y < _m->getHeight()-2 && !_m->isBlockedDown(*d)) 
		_scratch.push_back(dot::DIR_DOWN);
	}

	if (_scratch.size() > 1 && d->direction != dot::DIR_NONE)
	{
		// remove opposite direction to current direction from list
		for (int i = 0; i < _scratch.size(); i++)
		{
			if (_scratch.at(i) == dot::oppositeDirectionOf(d->direction)) {
				_scratch.erase(_scratch.begin()+i);
				break;
			}
		}
	}

	if (_scratch.size() == 0) {
		d->direction = dot::DIR_NONE;
	}
	else {
		d->direction = _scratch.at( rand() % _scratch.size() );
	}
}
