#include "maze.h"

using namespace std;

maze::maze(void)
{
}

maze::maze(int $w, int $h)
{
    _width = $w;
    _height = $h;

	_recommendedMaxDots = (_width*_height) / 15;

    fill(false);
}

maze::~maze(void)
{
}

void maze::fill(bool b)
{
	int x, y;

	// vert walls
	for (x = 0; x < _width; x++) {
	  for (y = 0; y < _height-1; y++) {
		_wallsV[x][y] = b;
	  }
	}
	// horiz walls
	for (y = 0; y < _height; y++) {
	  for (x = 0; x < _width-1; x++) {
		_wallsH[y][x] = b;
	  }
	}
}

void maze::makePerimeter()
{
	// vert walls
	for (int y = 0; y < _height-1; y++) {
	  _wallsV[0][y] = true;
	  _wallsV[_width-1][y] = true;
	}
	// horiz walls
	for (int x = 0; x < _width-1; x++) {
	  _wallsH[0][x] = true;
	  _wallsH[_height-1][x] = true;
	}
}

void maze::setStartPos(pos p)
{
	_startPos = p;  
}
pos* maze::getStartPos()
{
	return &_startPos;
}

void maze::setEndPos(pos p)
{
	_endPos = p;
}
pos* maze::getEndPos()
{
	return &_endPos;
}

int maze::getStartDirection()
{
	return _startDirection;
}
void maze::setStartDirection(int i)
{
	_startDirection = i;
}

int maze::getWidth()
{
	return _width;
}

int maze::getHeight()
{
	return _height;
}

bool maze::getWallV(int x, int y)
{
	return _wallsV[x][y];
}

void maze::setWallV(int x, int y, bool b)
{
	_wallsV[x][y] = b;
}

bool maze::getWallH(int y, int x)
{
return _wallsH[y][x];
}  

void maze::setWallH(int y, int x, bool b)
{
	_wallsH[y][x] = b;
}

int maze::getRecommendedMaxDots()
{
	return _recommendedMaxDots;
}


bool maze::isBlockedUp(dot d)
{
	return _wallsH[(int)d.getY()][(int)d.getX()];
}
bool maze::isBlockedDown(dot d)
{
	return _wallsH[(int)d.getY()+1][(int)d.getX()];
}
bool maze::isBlockedLeft(dot d)
{
	return _wallsV[(int)d.getX()][(int)d.getY()];
}
bool maze::isBlockedRight(dot d)
{
	return _wallsV[(int)d.getX()+1][(int)d.getY()];
}

bool maze::isBlockedUp(int x, int y)
{
	return _wallsH[y][x];
}
bool maze::isBlockedDown(int x, int y)
{
	return _wallsH[y+1][x];
}
bool maze::isBlockedLeft(int x, int y)
{
	return _wallsV[x][y];
}
bool maze::isBlockedRight(int x, int y)
{
	return _wallsV[x+1][y];
}

bool maze::isInBounds(dot d, bool $allowOneExtraSpace)
{
	int offset = int($allowOneExtraSpace);

	if (d.getX() <= 0-offset) return false;
	if (d.getX() >= _width-2+offset) return false;
	if (d.getY() <= 0-offset) return false; 
	if (d.getY() >= _height-2+offset) return false;

	return true;
}


void maze::crudePrint()
{
    // vertical slats
    for (int x = 0; x < getWidth(); x++)
    {
      for (int y = 0; y < getHeight() - 1; y++)
      {
        cout << getWallV(x,y);
      }
	  cout << endl;
    }
    
	  cout << endl;

	  // horiz slats
    for (int y = 0; y < getHeight(); y++)
    {
      for (int x = 0; x < getWidth() - 1; x++)
      {
        cout << getWallH(y,x);
      }
	  cout << endl;
    }
}
