#pragma once

#include <iostream>
#include <string>
#include <sstream>
#include "dot.h"
#include "pos.h"

class maze
{
	public:

		maze(void);
		maze(int $w, int $h);
		~maze(void);

		void fill(bool $b);

		void makePerimeter();
		void setStartPos(pos p);
		pos* getStartPos();

		void setEndPos(pos p);
		pos* getEndPos();

		int getStartDirection();
		void setStartDirection(int i);

		int getWidth();
		int getHeight();
		bool getWallV(int $x, int $y);
		void setWallV(int $x, int $y, bool $b);
		bool getWallH(int $y, int $x);
		void setWallH(int $y, int $x, bool $b);

		int getRecommendedMaxDots();

		bool isInBounds(dot d, bool $allowOneExtraSpace);
		bool isBlockedUp(dot d);
		bool isBlockedDown(dot d);
		bool isBlockedLeft(dot d);
		bool isBlockedRight(dot d);

		bool isBlockedUp(int x, int y);
		bool isBlockedDown(int x, int y);
		bool isBlockedLeft(int x, int y);
		bool isBlockedRight(int x, int y);

		void crudePrint();

	private:

		int _width;
		int _height;
		int _recommendedMaxDots;

		pos _startPos;
		int _startDirection;
		pos _endPos;

		bool _wallsV[100][100]; // change later
		bool _wallsH[100][100];
};
