#pragma once

#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <ctime>
#include "maze.h"
#include "pos.h"
#include "dot.h"

using std::vector;

class mazeUtil
{
	public:

		mazeUtil(void);
		~mazeUtil(void);

		void generate(maze* m);

		bool compareAscending(pos $a, pos $b);

	private:

		static const int DIR_NONE = -1;
		static const int DIR_LEFT = 0;
		static const int DIR_RIGHT = 1;
		static const int DIR_UP = 2;
		static const int DIR_DOWN = 3;

		pos doStartPosAndBreakWall();
		void doEndPosAndBreakWall();
		void makePath(pos p);
		int getLegalDirection(pos p);
		int* getRandomDirectionsList();
		bool isFull();
		void printPosArrayList(vector<pos> a);

		//

		maze* _m;
		int _w;
		int _h;

		vector<int> _scratch;
		vector<pos> _crumbs;
		vector<pos> _history; // .. all crumbs

		bool _visited[100][100]; // change me
};
