#include "mazeView2d.h"

mazeView2d::mazeView2d(void)
{
	setUnitSize(50);
}

mazeView2d::~mazeView2d(void)
{
}

void mazeView2d::setMaze(maze* pMaze)
{
	_m = pMaze;
}

void mazeView2d::setDots(dots* pDots)
{
	_dots = pDots;
}

float mazeView2d::getUnitSize()
{
	return _unit;
}

void mazeView2d::setUnitSize(float f)
{
	_unit = f;
	_halfUnit = _unit * 0.5;
}

float mazeView2d::getWidth()
{
	return ((float)_m->getWidth() - 1.0) * _unit;
}

float mazeView2d::getHeight()
{
	return ((float)_m->getHeight() - 1.0) * _unit;
}

void mazeView2d::draw()
{
	drawMaze();
	drawDots();
}

void mazeView2d::drawMaze()
{
	ofSetLineWidth(1);
	ofSetColor(0xe5e5e5);

    // vertical slats
    for (int x = 0; x < _m->getWidth(); x++)
    {
      for (int y = 0; y < _m->getHeight() - 1; y++)
      {
        if (_m->getWallV(x,y))
        {
          ofLine((float)x*_unit, (float)y*_unit, (float)x*_unit, (float)(y+1)*_unit);
        }
      }
    }
    
    // horiz slats
    for (int y = 0; y < _m->getHeight(); y++)
    {
      for (int x = 0; x < _m->getWidth() - 1; x++)
      {
        if (_m->getWallH(y,x))
        {
          ofLine((float)x*_unit, (float)y*_unit, (float)(x+1)*_unit, (float)y*_unit);
        }
      }
    }
}

void mazeView2d::drawDots()
{
	ofSetColor(0xff0000);

	for (int i = 0; i < _dots->getSize(); i++)
	{
		dot* d = _dots->getDotAt(i);
		float x = _unit * d->getX()  +  _halfUnit;
		float y = _unit * d->getY()  +  _halfUnit;
		ofEllipse(x+1,y+1, _unit-3,_unit-3);
	}
}
