#include "testApp.h"

using namespace std;

//--------------------------------------------------------------
void testApp::setup()
{
	srand( clock() );
	//srand(671);

	_w = 14;
	_h = 14;

	_ballSpeed = 0.0625;

	makeMaze();

	//

	ofBackground(0,0,0);
}

//--------------------------------------------------------------
void testApp::update()
{
	_dots.update();
}

//--------------------------------------------------------------
void testApp::draw()
{
	float ox = ((float)ofGetWidth() - _view2d.getWidth()) / 2;
	float oy = ((float)ofGetHeight() - _view2d.getHeight()) / 2;
	ofTranslate(ox,oy,0);
	_view2d.draw();
}

//--------------------------------------------------------------
void testApp::keyPressed(int key)
{
	switch (key)
	{
		case 356: // left
			_w -= 5;
			if (_w < 4) _w = 4;
			makeMaze();
			break;
		case 358: // right
			_w += 5;
			if (_w > 99) _w = 99;
			makeMaze();
			break;
		case 357: // up
			_h -= 5;
			if (_h < 4) _h = 4;
			makeMaze();
			break;
		case 359: // down
			_h += 5;
			if (_h > 99) _h = 99;
			makeMaze();
			break;


		case 61: // plus
		case 43:
			_ballSpeed *= 2;
			if (_ballSpeed > 1.0) _ballSpeed = 1.0;
			_dots.setDefaultSpeed(_ballSpeed);
			break;

		case 45: // minus
		case 95:
			_ballSpeed *= 0.5;
			if (_ballSpeed < 0.03125) _ballSpeed = 0.03125;
			_dots.setDefaultSpeed(_ballSpeed);
			break;
	}
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button)
{
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}
//--------------------------------------------------------------
//--------------------------------------------------------------
void testApp::makeMaze()
{
	// set up model

	_maze = maze(_w,_h);
	
	mazeUtil mu = mazeUtil();
	mu.generate(&_maze);

	_dots = dots();
	_dots.setMaze(&_maze);
	_dots.setDefaultSpeed(_ballSpeed);

	// set up view

	_view2d.setMaze(&_maze); // (no need to reinstantiate)
	_view2d.setDots(&_dots);
	
	float u = min((700.0 / (float)_w), (700.0 / (float)_h));
	_view2d.setUnitSize(u);
}
